/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: FactOrRule.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_FACT_OR_RULE_HPP_
#define _TOPS_FACT_OR_RULE_HPP_

#include "tops/common/Printable.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	class Fact;
	typedef boost::shared_ptr<Fact> FactPtr;
	class Rule;
	typedef boost::shared_ptr<Rule> RulePtr;

	/**
	 * 事実かルールです。
	 * このクラスは、パーサからの出力をラッピングします。
	 *
	 * @author トゥイー
	 */
	class FactOrRule : public Printable {
	private:
		typedef enum {
		    SMALLOPS_UNKNOWN = -1,
		    SMALLOPS_FACT,
		    SMALLOPS_RULE,
		} SMALLOPS_ELEMENT;

		SMALLOPS_ELEMENT m_type;
		FactPtr m_fact;
		RulePtr m_rule;

	public:
		/**
		 * デフォルトコンストラクタです。
		 */
		FactOrRule();

		/**
		 * 事実を構築します。
		 */
		FactOrRule(const FactPtr& fact);

		/**
		 * ルールを構築します。
		 */
		FactOrRule(const RulePtr& rule);

	public:
		/**
		 * 事実かどうかを判定します。
		 */
		bool isFact() const {
			return m_type == SMALLOPS_FACT;
		}

		/**
		 * 事実を取得します。
		 */
		FactPtr getFact() const {
			return (isFact()) ? m_fact : FactPtr();
		}

		/**
		 * プロダクションルールかどうかを判定します。
		 */
		bool isRule() const {
			return m_type == SMALLOPS_RULE;
		}

		/**
		 * プロダクション規則を取得します。
		 */
		RulePtr getRule() const {
			return (isRule()) ? m_rule : RulePtr();
		}

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
